/*
 * Copyright (c) 2003 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef spi00in_h
#define spi00in_h

#include <windows.h>

/*-------------------------------------------------------------------------*/
/* 摜\ */
/*-------------------------------------------------------------------------*/
#pragma pack(push)
#pragma pack(1) //\̂̃oE1oCgɂ
typedef struct PictureInfo {
	long left,top;		/* 摜WJʒu */
	long width;			/* 摜̕(pixel) */
	long height;		/* 摜̍(pixel) */
	WORD x_density;		/* f̐x */
	WORD y_density;		/* f̐x */
	short colorDepth;	/* fbit */
	HLOCAL hInfo;		/* 摜̃eLXg */
} PictureInfo;
#pragma pack(pop)

/*-------------------------------------------------------------------------*/
/* G[R[h */
/*-------------------------------------------------------------------------*/
#define SPI_NO_FUNCTION			-1	/* ̋@\̓CvgĂȂ */
#define SPI_ALL_RIGHT			0	/* I */
#define SPI_ABORT				1	/* R[obN֐0Ԃ̂œWJ𒆎~ */
#define SPI_NOT_SUPPORT			2	/* m̃tH[}bg */
#define SPI_OUT_OF_ORDER		3	/* f[^Ă */
#define SPI_NO_MEMORY			4	/* [mۏoȂ */
#define SPI_MEMORY_ERROR		5	/* [G[ */
#define SPI_FILE_READ_ERROR		6	/* t@C[hG[ */
#define	SPI_WINDOW_ERROR		7	/* JȂ (J̃G[R[h) */
#define SPI_OTHER_ERROR			8	/* G[ */
#define	SPI_FILE_WRITE_ERROR	9	/* ݃G[ (J̃G[R[h) */
#define	SPI_END_OF_FILE			10	/* t@CI[ (J̃G[R[h) */

/*-------------------------------------------------------------------------*/
/* '00IN'֐̃vg^Cv錾 */
/*-------------------------------------------------------------------------*/
typedef int (CALLBACK *SPI_PROGRESS)(int, int, long);
#ifdef __cplusplus
extern "C" {
#endif
	int __declspec(dllexport) __stdcall GetPluginInfo
			(int infono, LPSTR buf, int buflen);
	int __declspec(dllexport) __stdcall IsSupported(LPSTR filename, DWORD dw);
	int __declspec(dllexport) __stdcall GetPictureInfo
			(LPSTR buf,long len, unsigned int flag, PictureInfo *lpInfo);
	int __declspec(dllexport) __stdcall GetPicture
			(LPSTR buf,long len, unsigned int flag,
			 HANDLE *pHBInfo, HANDLE *pHBm,
			 SPI_PROGRESS lpPrgressCallback, long lData);
	int __declspec(dllexport) __stdcall GetPreview
			(LPSTR buf,long len, unsigned int flag,
			 HANDLE *pHBInfo, HANDLE *pHBm,
			 SPI_PROGRESS lpPrgressCallback, long lData);
#ifdef __cplusplus
}
#endif

#endif
